unit calc1;

interface

type
  waveheader = record
    main_chunk: string[3];    { 'RIFF' }
    length: longint;          { Gesamtlnge der Datei }
    chunk_type: string[3];    { 'WAVE' }

    sub_chunk: string[3];     { 'fmt ' }
    sub_chunk_length: longint;{ Lnge sub_chunk, immer =16 Bytes }
    format: word;             { momentan immer = 1 fr PCM-Code }
    modus: word;              { = 1 fr Mono, = 2 fr Stereo }
    sample_fq: longint;       { Sample-Frequenz }
    byte_p_sec: longint;      { Datendurchsatz pro Sekunde }
    byte_p_spl: word;         { Bytes per Sample; }
    bit_p_spl: word;          { Bits per Sample; 8, 12 oder 16 }

    data_chunk: string[3];    { Kennung fr Data-Bereich; ='data' }
    data_length: longint;     { Lnge des Data-Blocks }
  end;

  tracktyp = record
    position: real;
    startvol: byte;
    endvol: byte;
    smp: byte;
    startmove: real;
    endmove: real;
    startnote: real;
    endnote: real;
    startbal: byte;
    endbal: byte;
    loop_on: boolean;
    delay: longint;
    direction: shortint;
    lastsmp: byte;
    do_volsli: boolean;
    do_balsli: boolean;
    do_notsli: boolean;
    volvib: byte;
    do_balvib: boolean;
    notvib: byte;
    notvibpos: real;
    notvibmove: real;
    notvibamp: real;
    arp_on: boolean;
    arpcnt: longint;
    arpnum: byte;
    arpmove1: real;
    arpmove2: real;
    steadynote: real;
    steadybal: byte;
    steadyvol: byte;
    troff_smps: longint;
    tron_smps: longint;
    troff_count: longint;
    tron_count: longint;
    note_on: boolean;
    do_tremolo: boolean;
    do_note_cut: boolean;
    note_cut_count: longint;
    voltroff_count: longint;
    voltron_count: longint;
    voltroff_smps: longint;
    voltron_smps: longint;
    do_volume_tremolo: boolean;
    volume_on: boolean;
    balvibamp: real;
    balvibpos: real;
    balvibmove: real;
    volvibpos:real;
    volvibamp:real;
    volvibmove:real;
    do_retrig: boolean;
    retrigcount: longint;
    retrigsmps: longint
  end;

  sdectype = record
    smp: byte;
    position: real;
    vol: byte;
    bal: byte;
    posmove: real;
    trk: byte;
    count: longint;
    loop_on: boolean
  end;

var trackinfo: array[0..32] of tracktyp;
    berechnete_sekunden: real;
    tick: word;
    outputfile: file;
    maxvolume: longint;
    outputsize:longint;
    wav_header: waveheader;
    sdecay: array[-32..200] of sdectype;
    note_replaced: array[1..32] of boolean;
    sequentry: word;
    blockcount: word;
    writebuffer_poi: pointer;
    user_interrupt: boolean;
    optimize_already: boolean;
{    starttick: word;
    startsequentry: word;}


procedure calculate_pattern(nr:word);
procedure reset_trackinfo;
procedure init_writebuffer;
procedure round_up_wav;

implementation

uses interpl,
     fdw2_lch,
     fdw2_rch,
     pattload,
     dmfcheck,
     fio,
     fdwparam,
     get_fx,
     blknfo_1,
     blknfo_2,
     crt,
     dos,
     fdwinput,
     optimvol,
     fdw_disp,
     stoppuhr;

var
    mixposition: word;

procedure create_fdw_file;
  label neuer_name,hey;
var fremdfile: file;
  D: DirStr;
  N: NameStr;
  E: ExtStr;
  strbuf: string[6];
  dwordbuf: longint;
  elapsed_time:real;
  ver: word;
begin
  close(inputdmf);
  neuer_name:;
  if existing(fdw_dateiname) then
  begin
    beep;
    if zustimmung('File '+fdw_dateiname+' is already existing', 'Overwrite?', false)
      then begin assign(fremdfile, fdw_dateiname);erase(fremdfile) end
    else
      begin
        hey:;
        fdw_dateiname := textinput('Please enter new name', 'Filename (.FDW):', 40);
        FSplit(fdw_dateiname, D, N, E);
        if N = '' then
        begin
           errmsg('Hey!', 'I said: PLEASE ENTER A NEW NAME!!!');
           goto hey;
        end;
        if E = '' then
        E := '.FDW';
        fdw_dateiname := D + N + E;
        goto neuer_name;
      end;
  end;

  round_up_Wav;
  close(outputfile);
  rename(outputfile, fdw_dateiname);
  reset(outputfile,1);
  strbuf := 'DWD';
  strbuf[0] := 'F';
  blockwrite(outputfile, strbuf[0], 4);
  blockread(outputfile, dwordbuf,4);
  seek(outputfile, dwordbuf);
  strbuf := 'DWDATA';
  strbuf[0] := 'F';
  blockwrite(outputfile, strbuf[0], 7);
  ver := $0204;
  blockwrite(outputfile, ver, 2);
  optimize_already := false;
  blockwrite(outputfile, optimize_already, 1);
  { FDW - Header ist fertig }

  blockwrite(outputfile, dateiname[1][0], ord(dateiname[1][0])+1);
  blockwrite(outputfile, dateiname[2][0], ord(dateiname[2][0])+1);
  { Dateinamen }

  blockwrite(outputfile, maxblocklen, sizeof(maxblocklen));
  blockwrite(outputfile, blockanz, sizeof(blockanz));
  blockwrite(outputfile, dmf_dauer, sizeof(dmf_dauer));
  { Werte, die durch get_dauer ermittelt wurden }

  blockwrite(outputfile, maxvolume, sizeof(maxvolume));
  blockwrite(outputfile, sequentry, sizeof(sequentry));
  blockwrite(outputfile, tick, sizeof(tick));
  blockwrite(outputfile, blocklen, sizeof(blocklen));

  blockwrite(outputfile, sdecay, sizeof(sdecay));
  blockwrite(outputfile, trackinfo, sizeof(trackinfo));
  blockwrite(outputfile, berechnete_sekunden, sizeof(berechnete_sekunden));
  elapsed_time := stoppuhr_secs;
  blockwrite(outputfile, elapsed_time, sizeof(elapsed_time));
  blockwrite(outputfile, blockcount, sizeof(blockcount));
  blockwrite(outputfile, outputsize, sizeof(outputsize));

  blockwrite(outputfile, mem[blklenseg:blklenofs], blockcount * 2);
  blockwrite(outputfile, mem[blkampseg:blkampofs], blockcount * 6);

  blockwrite(outputfile, stereo, 1);
  blockwrite(outputfile, mixfreq, 4);
  blockwrite(outputfile, _8bit, 1);
  blockwrite(outputfile, interpol_on, sizeof(interpol_on));
  blockwrite(outputfile, sdecay_on, sizeof(sdecay_on));
  blockwrite(outputfile, sdectime, sizeof(sdectime));
  blockwrite(outputfile, arpsmps, sizeof(arpsmps));

  blockwrite(outputfile, tickspeedsystem, 1);
  blockwrite(outputfile, tickspeed, sizeof(tickspeed));
  blockwrite(outputfile, bpmspeed, sizeof(bpmspeed));


  close(outputfile);
  cls;
  textcolor(7);
  writeln ('FDW - file created: ', fdw_dateiname);
  writeln;
  writeln ('To continue calculation type: FDW2 /C:',fdw_dateiname);
  halt(0);
end;



procedure usermenu;

  var key: word;
begin
  stoppuhr_stop;
  cls;
  textbackground(0);
  gotoxy(5,7); textcolor(2);write  ('   Please choose:');
  gotoxy(5,8);              write  ('   --------------');


  gotoxy(5,11); textcolor(3); write('1) Interrupt calculation and create .FDW - file (continue later)');

  gotoxy(5,13);               write('2) Abort calculation and finish WAVE - file');

  gotoxy(5,15);               write('3) Continue calculation');


  repeat
    key := inkey;
    case key of
      49: create_fdw_file;
      50: begin
            round_up_wav;
            close(inputdmf);
            optimize_volume;
            close(outputfile);
            halt(0);
          end;
      {51: key := 27}
    end;
  until key = 51;
  user_interrupt := false;
  stoppuhr_start;


{  cls;
  user_interrupt := false;}
end;




procedure allocate_smoothdecay(t:integer);
  var index: word;
begin
  index := 0;
  repeat inc(index) until (index > 199) or (sdecay[index].trk = 0);
{  writeln('allocating SMOOTHDECAY on track #',track, '  --> index: ', index);}
  sdecay[index] := sdecay[-t];
  sdecay[index].count := sdecsmps
end;

procedure apply_smoothdecay;
  var index: word;
      phase: longint;
      mp: longint;
      sdecvolume: real;
begin
  trackinfo[0] := trackinfo[track];
  for index := 1 to 200 do
    with sdecay[index] do
    begin
      if trk > 0 then
      begin
{        writeln ('Calculating SmoothDecay of track #', trk);}
        trackinfo[track].smp := smp;
        trackinfo[track].loop_on := loop_on;
        trackinfo[track].volume_on := true;
        for mp := 0 to blocklen -1 do
        if trk > 0 then
        begin
          trackinfo[track].position := position;
          phase := interpol;
          sdecvolume := (1 - (sdecsmps - count)/sdecsmps)*vol; {1000-(1000 - 2)= 2}
          if stereo then
          begin
            add_lchan(mp, trunc(
              (phase*(255-bal)*sdecvolume) / 32));
            add_rchan(mp, trunc(
              (phase*bal*sdecvolume) / 32));
          end
          else
            add_lchan(mp, trunc((phase*255*sdecvolume) / 32));

          position := position + posmove;
          if count > 0 then dec(count) else trk := 0
        end
      end
    end;

  trackinfo[track] := trackinfo[0];
end;

procedure round_up_wav;
begin
  with wav_header do
  begin
    main_chunk := 'IFF';
    main_chunk[0] := 'R';
    length := outputsize + 44;
    chunk_type := 'AVE';
    chunk_type[0] := 'W';

    sub_chunk := 'mt ';
    sub_chunk[0] := 'f';
    sub_chunk_length := 16;
    format := 1;
    if stereo then
      modus := 2
    else
      modus := 1;
    sample_fq := mixfreq;
    if _8bit then
    begin
      byte_p_spl := modus;
      bit_p_spl := 8
    end
    else
    begin
      byte_p_spl := 2*modus;
      bit_p_spl := 16;
    end;
    byte_p_sec := sample_fq * byte_p_spl;
    data_chunk := 'ata';
    data_chunk[0] := 'd';
    data_length := outputsize
  end;

  seek(outputfile, 0);
  blockwrite(outputfile, wav_header, 44);
end;

procedure init_writebuffer;
var multi: byte;
begin

  if _8bit then multi := 1 else multi := 2;
  if stereo then multi := multi * 2;

getmem(writebuffer_poi, maxblocklen*multi);
end;

procedure reset_trackinfo;
var i :byte;
begin
  for i := 1 to 32 do
  with trackinfo[i] do
  begin
    position:= 0;
    startvol:=0;
    endvol:=0;
    smp:=0;
    startmove:=0;
    endmove:=0;
    startnote:=0;
    endnote:=0;
    if (i mod 2) = 0 then
    begin
    startbal:=0;
    endbal:=0
    end
    else
    begin
    startbal:=255;
    endbal:=255
    end;
    loop_on:=false;
    delay:=0;
    direction:=1;
    lastsmp:= 0;
  end;

end;



procedure inc_trackpos_arpeggio;
begin
    with trackinfo[track] do
    begin
      if arpcnt > 0 then dec(arpcnt) else
      begin
        arpcnt := arpsmps;
        if arpnum < 3 then inc(arpnum) else
          arpnum := 0;
      end;

      if arpnum = 0 then position := position + startmove * direction
      else
        if arpnum = 1 then position := position + arpmove1 * direction
        else
          position := position + arpmove2 * direction;
    end
end;


function zig(wert: real):real;
  var workwert:real ;
begin
  workwert := wert - trunc(wert);
  if workwert < 0 then workwert := 1+workwert;

  if workwert < 0.5 then zig := workwert * 2
  else zig := -(workwert-0.5)*2;
end;


function square(wert: real):real;
  var workwert:real ;
begin
  workwert := wert - trunc(wert);
  if workwert < 0 then workwert := 1+workwert;

  if workwert < 0.5 then square := 1
  else square := -1
end;

procedure inc_trackpos_notevib;
  var phase: real;
begin
  phase := 0;
  with trackinfo[track] do
  begin
    if notvib = 1 then phase := sin(notvibpos*2*pi);
    if notvib = 2 then phase := zig(notvibpos);
    if notvib = 3 then phase := square(notvibpos);

    endnote := steadynote + phase * notvibamp;
{    writeln (endnote:0:3);}
    if endnote < 1 then endnote := 1
    else if endnote > 108 then endnote := 108;

    endmove := movewert(endnote);

    position := position + endmove*direction;
    notvibpos := notvibpos + notvibmove
  end
end;

procedure inc_trackpos_normal;
begin

if trackinfo[track].note_on then
begin
if trackinfo[track].notvib = 0 then begin
    if trackinfo[track].arp_on then
      inc_trackpos_arpeggio
    else with trackinfo[track] do
      position := position + startmove * direction;
end
else inc_trackpos_notevib
end

end;

procedure inc_trackpos_slide;
  var m1,m2:real;
begin
if trackinfo[track].notvib = 0 then begin
  {if trackinfo[track].arp_on then
    inc_trackpos_arpeggio
  else
  begin}
    m1 := 1-(mixposition / blocklen);
    m2 := (mixposition / blocklen);
    trackinfo[track].position := trackinfo[track].position
      + (trackinfo[track].startmove*m1 + trackinfo[track].endmove*m2)
       * trackinfo[track].direction;
  {end}
end
else inc_trackpos_notevib
end;


  procedure check_note_tremolo;
  begin

    if trackinfo[track].do_note_cut then
    with trackinfo[track] do
    begin
      if note_cut_count > 0 then
      begin
        dec(note_cut_count);
        if note_cut_count = 0 then
        begin
          startmove := 0; endmove := 0;
          startnote := 0; endnote := 0;
          note_on := false;
        end
      end
    end;



    if trackinfo[track].do_tremolo then
    with trackinfo[track] do
    begin
      if note_on then begin
        if tron_count > 0 then dec(tron_count)
          else begin
               tron_count := tron_smps;
               note_on := not note_on
          end
      end
      else
      begin
        if troff_count > 0 then dec(troff_count)
          else begin
               troff_count := troff_smps;
               note_on := not note_on
          end
      end
    end;


    if trackinfo[track].do_volume_tremolo then
    with trackinfo[track] do
    begin
      if volume_on then begin
{        write(' ', voltron_count);}
        if voltron_count > 0 then dec(voltron_count)
          else begin
{               wait;}
               voltron_count := voltron_smps;
               volume_on := false;
          end
      end
      else
      begin
        if voltroff_count > 0 then dec(voltroff_count)
          else begin
               voltroff_count := voltroff_smps;
               volume_on := true;
          end
      end
    end




  end;


procedure retrighandler;
begin
  with trackinfo[track] do
  begin
    if retrigcount > 0 then dec(retrigcount)
    else begin
      retrigcount := retrigsmps;
      position := 0;
{      writeln ('             YO! Sample Retriggedpopigged. (', retrigsmps,')');}
    end
  end
end;


procedure ADD_TRACK_no_fx;
  var sampnr: byte;
      phase: longint;
      startbal: byte;
      startvol: byte;
begin
  sampnr := trackinfo[track].smp;
  startbal := trackinfo[track].startbal;
  startvol := trackinfo[track].startvol;

  for mixposition := 0 to blocklen - 1 do
  if trackinfo[track].smp > 0 then
  begin

    check_note_tremolo;
    if trackinfo[track].do_retrig then retrighandler;

    if trackinfo[track].delay > 0 then
      dec(trackinfo[track].delay) else
    begin
      phase := interpol;
{      if track = 1 then write(trackinfo[track].volume_on,phase);}
      if stereo then
      begin
        add_lchan(mixposition,
          (phase*(255-startbal)*startvol) div 32);
        add_rchan(mixposition,
          (phase*startbal*startvol) div 32);
      end
      else
        add_lchan(mixposition, (phase*255*startvol) div 32);

      if trackinfo[track].do_notsli
        then inc_trackpos_slide else inc_trackpos_normal;
    end
  end {for mixposition / if }

end;


procedure ADD_TRACK_volsli;
  var sampnr: byte;
      phase: longint;
      startbal: byte;
      startvol: byte;
      endvol:byte;
      m1, m2:real;
begin
  sampnr := trackinfo[track].smp;
  startbal := trackinfo[track].startbal;
  startvol := trackinfo[track].startvol;
  endvol := trackinfo[track].endvol;

  for mixposition := 0 to blocklen - 1 do
  if trackinfo[track].smp > 0 then
  begin

      check_note_tremolo;
    if trackinfo[track].do_retrig then retrighandler;

  if trackinfo[track].delay > 0 then
    dec(trackinfo[track].delay) else
  begin
    phase := interpol;
    m1 := 1-(mixposition / blocklen);
    m2 := (mixposition / blocklen);

    if stereo then
    begin
      add_lchan(mixposition, trunc(
        (phase*(255-startbal)*(startvol*m1+endvol*m2)) / 32));
      add_rchan(mixposition, trunc(
        (phase*startbal*(startvol*m1+endvol*m2)) / 32));
    end
    else
      add_lchan(mixposition,trunc( (phase*255*(startvol*m1+endvol*m2)) / 32));

    if trackinfo[track].do_notsli
      then inc_trackpos_slide else inc_trackpos_normal;
  end;
  end;

end;



procedure ADD_TRACK_balsli;
  var sampnr: byte;
      phase: longint;
      startbal: byte;
      startvol: byte;
      endbal:byte;
      m1, m2:real;
begin
  sampnr := trackinfo[track].smp;
  startbal := trackinfo[track].startbal;
  endbal := trackinfo[track].endbal;
  startvol := trackinfo[track].startvol;

  for mixposition := 0 to blocklen - 1 do
  if trackinfo[track].smp > 0 then
  begin

    check_note_tremolo;
    if trackinfo[track].do_retrig then retrighandler;

  if trackinfo[track].delay > 0 then
    dec(trackinfo[track].delay) else
  begin
    phase := interpol;
    m1 := 1-(mixposition / blocklen);
    m2 := (mixposition / blocklen);

    if stereo then
    begin
      add_lchan(mixposition, trunc(
        (phase*(255-(startbal*m1+endbal*m2))*startvol) / 32));
      add_rchan(mixposition, trunc(
        (phase*(startbal*m1+endbal*m2)*startvol) / 32));
    end
    else
      add_lchan(mixposition, (phase*255*startvol) div 32);

    if trackinfo[track].do_notsli
      then inc_trackpos_slide else inc_trackpos_normal;
  end;
  end;

end;


procedure ADD_TRACK_balvib;
  var sampnr: byte;
      phase: longint;
      startvol: byte;
{      startbal: byte;}
      vibphase: real;
      endbal_real: real;
begin
  sampnr := trackinfo[track].smp;
  startvol := trackinfo[track].startvol;
{  startbal := trackinfo[track].startbal;}

  for mixposition := 0 to blocklen - 1 do
  begin

  if trackinfo[track].smp > 0 then begin
    check_note_tremolo;
    if trackinfo[track].do_retrig then retrighandler;

  if trackinfo[track].delay > 0 then
    dec(trackinfo[track].delay) else
  begin

    phase := interpol;
  end;
(***************************)
if stereo then begin
  vibphase := 0;
  with trackinfo[track] do
  begin
    if do_balvib then vibphase := sin(balvibpos*2*pi);

    endbal_real := steadybal + vibphase * balvibamp;

    if endbal_real < 0 then endbal_real := 0
    else if endbal_real > 255 then endbal_real := 255;
    endbal := trunc(endbal_real);

{    writeln ('Vibphase: ', vibphase:0:3);}
    balvibpos := balvibpos + balvibmove

  end
end;

(***************************)
  if trackinfo[track].smp > 0 then
  begin
    if stereo then
    begin
      add_lchan(mixposition, trunc(
        (phase*(255-endbal_real)*startvol) / 32));
      add_rchan(mixposition, trunc(
        (phase*endbal_real*startvol) / 32));
    end
    else
      add_lchan(mixposition, (phase*255*startvol) div 32);

    if trackinfo[track].do_notsli
      then inc_trackpos_slide else inc_trackpos_normal;
  end

  end
  end

end;


procedure ADD_TRACK_volvib;
  var sampnr: byte;
      phase: longint;
{      startvol: byte;}
      startbal: byte;
      vibphase: real;
      endvol_real: real;
begin
  sampnr := trackinfo[track].smp;
{  startvol := trackinfo[track].startvol;}
  startbal := trackinfo[track].startbal;

  for mixposition := 0 to blocklen - 1 do
  begin

  if trackinfo[track].smp > 0 then begin
    check_note_tremolo;
    if trackinfo[track].do_retrig then retrighandler;

  if trackinfo[track].delay > 0 then
    dec(trackinfo[track].delay) else
  begin

    phase := interpol;
  end;
(***************************)
{if stereo then begin}
  vibphase := 0;
  with trackinfo[track] do
  begin
    if volvib=1 then vibphase := sin((volvibpos+0.25)*2*pi);
    if volvib=2 then vibphase := zig(volvibpos+0.25);
    if volvib=3 then vibphase := square(volvibpos+0.25);

    endvol_real := (steadyvol ) + (vibphase-1) * volvibamp;

    if endvol_real < 0 then endvol_real := 0
    else if endvol_real > 254 then endvol_real := 254;
    endvol := trunc(endvol_real);

{    writeln ('Vibphase: ', vibphase:0:3);}
    volvibpos := volvibpos + volvibmove

  end;
{end;}

(***************************)
  if trackinfo[track].smp > 0 then
  begin
    if stereo then
    begin
      add_lchan(mixposition, trunc(
        (phase*(255-startbal)*endvol_real) / 32));
      add_rchan(mixposition, trunc(
        (phase*startbal*endvol_real) / 32));
    end
    else
      add_lchan(mixposition, trunc( (phase*255*endvol_real) / 32) );

    if trackinfo[track].do_notsli
      then inc_trackpos_slide else inc_trackpos_normal;
  end

  end
  end

end;


procedure ADD_TRACK_tickdelay;
  var sampnr: byte;
      phase: longint;
      endbal: byte;
      endvol: byte;
begin
  sampnr := trackinfo[track].smp;
  endbal := trackinfo[track].endbal;
  endvol := trackinfo[track].endvol;

  for mixposition := 0 to blocklen - 1 do
  if trackinfo[track].smp > 0 then
  begin

      phase := interpol;
      if stereo then
      begin
        add_lchan(mixposition,
          (phase*(255-endbal)*endvol) div 32);
        add_rchan(mixposition,
          (phase*endbal*endvol) div 32);
      end
      else
        add_lchan(mixposition, (phase*255*endvol) div 32);

      inc_trackpos_normal
  end

end;



procedure amplify_and_write_to_disk;
  var amp: real;
      i: word;
  buffer: longint;
  intbuf: integer;
  shortintbuf: shortint;
  multi: byte;
  bytebuf: byte;
  intbuf2: integer;
begin
  for i := 0 to blocklen-1 do
  begin
    buffer := read_lchan(i);
    if abs(buffer) > maxvolume then maxvolume := abs(buffer);
    if stereo then
    begin
      buffer := read_rchan(i);
      if abs(buffer) > maxvolume then maxvolume := abs(buffer);
    end;
  end;
  amp := 32767 / maxvolume;

  if stereo then
    for i := 0 to blocklen-1 do
    begin
      intbuf := trunc(read_lchan(i)*amp);
      intbuf2 := intbuf;

      if _8bit then
      begin
        shortintbuf := intbuf div 256;
        bytebuf := shortintbuf + 128;
        mem[seg(writebuffer_poi^):ofs(writebuffer_poi^)+2*i] := bytebuf
      end
      else
        memw[seg(writebuffer_poi^):ofs(writebuffer_poi^)+4*i] := intbuf;

      intbuf := trunc(read_rchan(i)*amp);

      if _8bit then
      begin
        shortintbuf := intbuf div 256;
        bytebuf := shortintbuf + 128;
        mem[seg(writebuffer_poi^):ofs(writebuffer_poi^)+2*i+1] := bytebuf
      end
      else
        memw[seg(writebuffer_poi^):ofs(writebuffer_poi^)+4*i+2] := intbuf
    end
  else

    for i := 0 to blocklen-1 do {mono}
    begin
      intbuf := trunc(read_lchan(i)*amp);
      if _8bit then
      begin
        shortintbuf := intbuf div 256;
        bytebuf := shortintbuf + 128;
        mem[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i] := bytebuf
      end
      else
        memw[seg(writebuffer_poi^):ofs(writebuffer_poi^)+2*i] := intbuf
    end;



  if _8bit then multi := 1 else multi := 2;
  if stereo then
  begin
    blockwrite(outputfile, memw[seg(writebuffer_poi^):ofs(writebuffer_poi^)], blocklen*2*multi);
    inc(outputsize, blocklen*2*multi);
    free_disk_space := free_disk_space - blocklen*2*multi;
    show_free_disk_space;
  end
  else
  begin
    blockwrite(outputfile, memw[seg(writebuffer_poi^):ofs(writebuffer_poi^)], blocklen*multi);
    inc(outputsize, blocklen*multi);
    free_disk_space := free_disk_space - blocklen*multi;
    show_free_disk_space;
  end;

  set_block_amplify(blockcount, amp);
  set_block_laenge(blockcount, blocklen);

  inc(blockcount);

  berechnete_sekunden := berechnete_sekunden + (blocklen / mixfreq)
end;





procedure check_fx_appearing_and_ADD_TRACK;
begin
  with trackinfo[track] do
  begin
    if startnote = endnote then do_notsli := false else do_notsli := true;
    if startvol = endvol then do_volsli := false else do_volsli := true;
    if startbal = endbal then do_balsli := false else do_balsli := true;


    if not (do_volsli or do_balsli or (volvib>0) or do_balvib)
      then ADD_TRACK_no_fx else

    if do_volsli then ADD_TRACK_volsli else

    if do_balsli then ADD_TRACK_balsli else

    if (volvib>0) then ADD_TRACK_volvib else

    if do_balvib then ADD_TRACK_balvib;

  end;

end;




procedure calculate_pattern(nr:word);
  var i: word;
  tickdelayticks: byte;
  blocklen_old: longint;
  userkey: word;
begin
  load_pattern(nr);

  if not continue_fdw then starttick := 0;
  user_interrupt := false;
  for tick := starttick to ticks-1 do
  begin
  if user_interrupt then usermenu;

{  if disk_full then
  begin
    (* Disk full *)
     stoppuhr_stop;
     round_up_wav;
     close(inputdmf);
     optimize_volume;
     close(outputfile);
     halt(0);
  end;}

  userkey := inkey;
  if userkey = 27 then user_interrupt := true;

    read_global_track(tick);
    if tickspeedsystem then
      blocklen := round(mixfreq / (tickspeed+1)*4)
    else
      blocklen := round(mixfreq*60/bpmspeed/tpb);

      clear_lchan;
      if stereo then clear_rchan;

    for track := 1 to tracks do
    begin
{      cls;}
      gotoxy(4,13); textcolor(14); textbackground(1);
{      writeln ('  FRANKUS DISK WRITER Version 2.03');
      writeln;
      writeln ('  programmiert von Frank Grtzenbach, der diesem Programm spter auch noch');
      writeln ('  eine schne Benutzeroberflche bzw. schne Anzeigen machen wird.');
      writeln;
      writeln ('    - Frank Grtzenbach (Zatzen)  15. 01. 1997');

      writeln;
      writeln (' Und hier ein paar Informationen:');}
{      write('Song: ');
{      if ord(songname[0]) > 0 then writeln (songname) else writeln('(',dateiname[1],')');
 }   textcolor(7); textbackground(0);
     gotoxy(4,15);
      writeln ('    Track #',track, '       ');
      gotoxy(4,16);
      writeln('    Sequenzer: ', sequentry,'/',sequenzerentries,'  Zeile ',tick+1, '/',ticks, '       ');
      gotoxy(4,17);
      writeln ('    ', berechnete_sekunden:0:2,' Sekunden von ', dmf_dauer:0:2,' berechet.', '       ');
      if stoppuhrticks > 0 then writeln ('    Verstrichene Zeit: ', timestring(stoppuhr_secs), '                  ');
      if berechnete_sekunden > 0 then
        begin
      gotoxy(4,19);
         writeln ('    Verbleibende Zeit bis zur Lautstrkeoptimierung: ');
      gotoxy(4,20);
  writeln('    ', timestring( trunc((stoppuhr_secs/berechnete_sekunden)*(dmf_dauer-berechnete_Sekunden))), '               ');
        end;

      note_replaced[track] := false;
      with trackinfo[track] do
      begin
        arp_on := false;
        startvol := endvol;
        startbal := endbal;
        startnote := endnote;
        startmove := endmove;
      end;
      for i := 1 to maxtracks do
        note_replaced[i] := false;
      geteffekte;

      if (tracks < maxtracks) and (tick = 0) then  { SDECAY - Vorbereitung im Falle der Kanalabschaltung }
        for i := tracks+1 to maxtracks do
        begin
          note_replaced[i] := true;
          trackinfo[i].smp := 0;
        end;

      if trackinfo[track].notvib = 0 then trackinfo[track].steadynote := trackinfo[track].endnote;
      if not trackinfo[track].do_balvib then trackinfo[track].steadybal := trackinfo[track].endbal;
      {if trackinfo[track].volvib = 0 then trackinfo[track].steadyvol := trackinfo[track].endvol;}




    if tick = 0 then
     for i := tracks+1 to maxtracks do
     begin
      if note_replaced[i]
      and sdecay_on[i]
      and (sdecay[-i].trk > 0)
      and (sdecay[-i].smp > 0)
      and ((sdecay[-i].position < sample[sdecay[-i].smp].length)
        or sdecay[-i].loop_on)
      and (sdecay[-i].vol > 0)
      and (sdecay[-i].posmove > 0) then allocate_smoothdecay(i);
      with sdecay[-i] do
      begin
        smp := 0;
        position := 0;
        vol := 0;
        bal := 0;
        posmove := 0;
        trk := 0;
        loop_on := false;
      end
     end;


      if note_replaced[track]
      and sdecay_on[track]
      and (sdecay[-track].trk > 0)
      and (sdecay[-track].smp > 0)
      and ((sdecay[-track].position < sample[sdecay[-track].smp].length)
        or sdecay[-track].loop_on)
      and (sdecay[-track].vol > 0)
      and (sdecay[-track].posmove > 0) then allocate_smoothdecay(track);


      with sdecay[-track] do
      begin
        smp := 0;
        position := 0;
        vol := 0;
        bal := 0;
        posmove := 0;
        trk := 0;
        loop_on := false;
      end;

      if (trackinfo[track].smp > 0)
      AND NOT ((trackinfo[track].startnote = trackinfo[track].endnote)
      AND (trackinfo[track].startnote = 0)) then
        check_fx_appearing_and_ADD_TRACK
      else if trackinfo[track].do_balvib or (trackinfo[track].volvib > 0)
      then check_fx_appearing_and_ADD_TRACK;

      with sdecay[-track] do
      begin
        smp := trackinfo[track].smp;
        position := trackinfo[track].position;
        vol := trackinfo[track].endvol;
        bal := trackinfo[track].endbal;
        posmove := trackinfo[track].endmove;
        trk := track;
        loop_on := trackinfo[track].loop_on;
      end

    end;

    apply_smoothdecay;
    amplify_and_write_to_disk;


    if (tickdelay div 16)>0 then
    begin
      for tickdelayticks := 1 to (tickdelay div 16) do
      begin
  (****** tickdelay grob *******)
        clear_lchan;
        if stereo then clear_rchan;
        for track := 1 to tracks do
          add_track_tickdelay;
        apply_smoothdecay;
        amplify_and_write_to_disk
      end
    end;
(****** tickdelay fein *******)
    if (tickdelay and 15)>0 then
    begin
      blocklen_old := blocklen;
      blocklen := (blocklen * (tickdelay and 15)) div 16;
      clear_lchan;
      if stereo then clear_rchan;
      for track := 1 to tracks do
        add_track_tickdelay;
      apply_smoothdecay;
      amplify_and_write_to_disk;
      blocklen := blocklen_old;
    end



  end;
  starttick := 0;
end;
var i:word;

begin
blockcount := 0;
outputsize := 0;
for i := 1 to 500 do sdecay[i].trk := 0;
end.

