UNIT dmfcheck;

interface

procedure dmf_checken(datei:string);

type
  sampletyp = record
    length: longint;
    loopstart: longint;
    loopend: longint;
    c3freq: word;
    volume: byte;  { bis hier 15 Bytes }
    loop_on: boolean;
    _16bit: boolean;
    offset: longint;
  end;


var songname: string[30];
    composername: string[20];
    sequenzer: array[1..1024] of word;
    sequenzerentries: word;
    patternentries: word;
    maxtracks: byte;
    maxticks: word;
    patternoffset: array[1..1024] of longint;
    sampentries: byte;
    sample: array[1..255] of sampletyp;

implementation

uses fio,fdwparam;

var dmf: file;

procedure abbruch;
begin
close(dmf);
cls;
writeln ('FDW2 abgebrochen.');
halt(1);
end;

procedure checkblock(kennung:string);
var check:string[4];
begin
  blockread(dmf, check[1], 4);
  check[0] := chr(4);
  if not (check = kennung) THEN
  begin
    beep;
    if kein_batchbetrieb then errmsg('Fehler:', 'Fehler in DDMF: '+kennung+' --> '+check);
    abbruch;
  end;
end;

procedure check_header;
var buf: byte;
begin
  checkblock('DDMF');
  blockread(dmf, buf, 1);
  if (not (buf = 8)) and kein_batchbetrieb then
    if not zustimmung ('Unbekannte DDMF-Version!', 'Trotzdem fortfahren?',true)
     or inputescape
      then abbruch;

  seek(dmf, $d);
  blockread(dmf, songname[1], 30);
    buf := 1; songname[0] := chr(30);
  while (buf < 31) and (ord(songname[buf]) > 0) do inc(buf);
  songname[0] := chr(buf - 1);

  blockread(dmf, composername[1], 20);
    buf := 1; composername[0] := chr(20);
  while (buf < 21) and (ord(composername[buf]) > 0) do inc(buf);
  composername[0] := chr(buf - 1);
end;

procedure check_CMSG;
var blklen: longint;
begin
  seek(dmf, 66);
  checkblock('CMSG');

  blockread(dmf, blklen, 4);
  seek(dmf, filepos(dmf)+blklen);
end;

procedure check_SEQU;
var check: string[4];
    blklen: longint;
begin
  checkblock('SEQU');

  blockread(dmf, blklen, 4);

  seek(dmf, filepos(dmf)+4);

  blockread(dmf, sequenzer[1], blklen-4);

  sequenzerentries := (blklen-4) DIV 2;
end;

procedure check_PATT;
var i: word;
    pattlen: longint;
    ticks: word;
begin
  checkblock('PATT');
  seek(dmf, filepos(dmf)+4);

  blockread(dmf, patternentries, 2);

  blockread(dmf, maxtracks, 1);

  maxticks := 0;
  for i := 1 to patternentries do
  begin
    patternoffset[i] := filepos(dmf);
    seek(dmf, patternoffset[i] + 2);
    blockread(dmf, ticks, 2);
    if ticks > maxticks then maxticks := ticks;
    blockread(dmf, pattlen, 4);
    seek(dmf, filepos(dmf) + pattlen);
  end;
end;

procedure check_SMPI;
  var buf, i:byte;
begin
  checkblock('SMPI');
  seek(dmf, filepos(dmf)+4);

  blockread(dmf, sampentries, 1);

  for i := 1 to sampentries do
  begin
    blockread(dmf, buf, 1);
    seek(dmf, filepos(dmf) + buf);  { samplename berspringen }

    blockread(dmf, sample[i], 15);  { die ersten 15 Bytes des Samplestyps beladen }


    blockread(dmf, buf, 1);
    seek(dmf, filepos(dmf) + 14);

    if (buf AND 1) > 0 then sample[i].loop_on := true
      else sample[i].loop_on := false;
    if (buf and 2) > 0 then sample[i]._16bit := true
      else sample[i]._16bit := false;

    if sample[i]._16bit then sample[i].length := sample[i].length div 2;

    if (buf and 12) > 0 then begin
      beep;
      if kein_batchbetrieb then errmsg('Problem:', 'Komprimierte Samples knnen nicht verwertet werden!');
      abbruch
    end;

    if (buf and 128) > 0 then begin
      beep;
      if kein_batchbetrieb then errmsg('Problem:', 'Samples in Bibliotheken knnen nicht verwertet werden!');
      abbruch
    end;


  end;
end;


procedure check_SMPD;
var i : byte;
    samlen: longint;
begin
  checkblock('SMPD');
  seek(dmf, filepos(dmf)+4);
  for i := 1 to sampentries do
  begin
    blockread(dmf, samlen, 4);
    sample[i].offset := filepos(dmf);
    seek(dmf, sample[i].offset + samlen);
  end;
end;


procedure dmf_checken(datei:string);
begin
  assign(dmf, datei);
  reset(dmf, 1);

  check_header;
  check_CMSG;
  check_SEQU;
  check_PATT;
  check_SMPI;
  check_SMPD;

  close(dmf);
end;

end.