UNIT FIO;
{$G+}
INTERFACE

procedure beep;
FUNCTION InitialVideo: STRING;
FUNCTION INKEY: WORD;
function existing(dateiname:string):boolean;
FUNCTION LongValue(str:string):LONGINT;
FUNCTION RealValue(str:string):REAL;
FUNCTION ByteValue(str:string):shortint;
FUNCTION WordValue(str:string):integer;
PROCEDURE TextPset(X, Y: BYTE; Zeichen: CHAR; Farbe, Hintergrund:BYTE);
PROCEDURE TextLineFill(X,Y:BYTE; Zeichen:CHAR;Farbe,Hintergrund,Laenge:BYTE);
PROCEDURE TextLineGet(X,Y:BYTE; zielseg, zielofs: WORD; Laenge:BYTE);
PROCEDURE TextLinePut(X,Y:BYTE; quellseg, quellofs: WORD; Laenge:BYTE);
PROCEDURE Shadow(X,Y:BYTE);
FUNCTION TextInput(headline, help:STRING; Breite: BYTE): STRING;
PROCEDURE CursorAttr(blink, startline, endline:byte);
FUNCTION InputWord(headline, help:STRING; Breite: BYTE): WORD;
FUNCTION InputLongInt(headline, help:STRING; Breite: BYTE): LONGINT;
FUNCTION InputReal(headline, help:STRING; Breite: BYTE): Real;
FUNCTION zustimmung(headline, help: STRING; default:boolean): boolean;
FUNCTION instr(str1,str2:string):BOOLEAN;
FUNCTION potenz(a,b:REAL):REAL;
FUNCTION TIMER:REAL;
function intstr(wert:longint):string;
PROCEDURE ErrMsg(headline, msg:STRING);
PROCEDURE CLS;
PROCEDURE WAIT;
PROCEDURE Message(headline, msg:STRING);
procedure clearmsg;
function fit(wert:real):longint;

VAR InputEscape: BOOLEAN;

IMPLEMENTATION
USES CRT,dos;
VAR TextDataSegm: WORD;
TextBackup: ARRAY[6..18, 1..80] OF WORD;


procedure beep; begin write(chr(7)); end;

function intstr(wert:longint):string;
  var s:string[12];
begin
  str(wert, s);
  intstr := s;
end;

function fit(wert:real):longint;
begin
  if wert - trunc(wert) = 0 then
    fit := trunc(wert)
  else
    fit := trunc(wert) + 1;
end;

FUNCTION LongValue(str:string):LONGINT;
  var code:integer; buf:longint;
BEGIN
  val(str, buf, code);
  LongValue := buf
END;

function existing(dateiname:string):boolean;
  var dirinfo: searchrec;
begin
  findfirst(dateiname, 37, dirinfo);
  if doserror = 0 then existing := true
    else existing := false;
end;

FUNCTION RealValue(str:string):REAL;
  var code:integer; buf: real;
BEGIN
  val(str, buf, code);
  RealValue := buf
END;

FUNCTION ByteValue(str:string):shortint;
  var code: integer; buf: shortint;
BEGIN
  val(str, buf, code);
  bytevalue := buf
END;

FUNCTION WordValue(str:string):integer;
  var code:integer; buf:integer;
BEGIN
  val(str, buf, code);
  wordvalue := buf;
END;

FUNCTION TIMER:REAL;
var upper,lower:WORD;
    timerticks:longint;
BEGIN
  ASM
    XOR AH, AH;
    INT 1AH;
    MOV upper, CX;
    MOV lower, DX;
  END;
TIMERticks := 65536*upper+lower;
timer := timerticks / 18.206481482
END;


FUNCTION instr(str1,str2:string):BOOLEAN;
var c,i:INTEGER;
label gleich;
BEGIN
FOR i := 1 TO ORD(str2[0])-ORD(str1[0])+1 DO BEGIN
  c := 1;
  WHILE str1[c] = str2[c+i-1] DO INC(c);
  IF c > ORD(str1[0]) THEN GOTO gleich;
END;
INSTR := FALSE; EXIT;
gleich: INSTR := TRUE;
END;


FUNCTION potenz(a,b:REAL):REAL;
BEGIN
potenz := EXP(b*ln(a));
END;

PROCEDURE CursorAttr(blink, startline, endline:byte);
ASSEMBLER;
ASM
MOV AH, 1;
MOV CH, startline;
MOV AL, blink;
SHL AL, 5;
ADD CH, AL;
MOV CL, endline;
INT 10h;
END;


PROCEDURE TextLineFill(X,Y:BYTE; Zeichen:CHAR;Farbe,Hintergrund,Laenge:BYTE);
ASSEMBLER;
ASM
PUSH ES;
PUSH DI;
MOV ES, TextDataSegm;
XOR CX, CX;
XOR BX, BX;
MOV CL, Y;
DEC CL;
MOV AX, CX;
SHL AX, 6;
MOV BL, X;
DEC BL;
ADD BX, AX;
MOV AX, CX;
SHL AX, 4;
ADD BX, AX;
SHL BX, 1;
MOV DI, BX;
{ Zielregister haben nun die Startwerte }

XOR BX, BX;
MOV BL, Zeichen;
MOV BH, Hintergrund;
SHL BH, 4;
ADD BH, Farbe;
MOV CL, Laenge;
MOV AX, 2;
@textpset:;
MOV ES:[DI], BX;
ADD DI, AX;
LOOP @textpset;

POP DI;
POP ES;
END;

PROCEDURE Shadow(X,Y:BYTE);
ASSEMBLER;
ASM
PUSH ES;
PUSH DI;

XOR CX, CX;
XOR BX, BX;
MOV CL, Y;
DEC CL;
MOV AX, CX;
MOV BL, X;
DEC BL
SHL AX, 6;
ADD BX, AX;
MOV AX, CX;
SHL AX, 4;
ADD BX, AX;
SHL BX, 1;
INC BX;
MOV ES, TextDataSegm;
MOV DI, BX;
{ Register haben nun ihre Werte... }

MOV DL, ES:[DI];
MOV DH, DL;
AND DL, 15;
SHR DH, 4;
{ Farbe steht in DL, Hintergrund in DH }

CMP DL, 2;
JB @kleiner_als_2;
CMP DL, 7;
JA @groesser_als_7;
MOV DL, 8;    { Farben 2 - 7 --> 8 }
JMP @fertig;
@kleiner_als_2:; { Farben 1 + 0 --> 0 }
XOR DL, DL;
JMP @fertig;
@groesser_als_7:;
SUB DL, 8;
@fertig:;
{ Farb-Treatment }

CMP DH, 7;
JA @blink;
CMP DH, 3;
JNE @nicht_3; {Farbe 3 wird zu Farbe 1}
MOV DH, 1;
JMP @blinkt_nicht;
@nicht_3:;
XOR DH, DH;   {Alle anderen zu 0 }
JMP @blinkt_nicht;
@blink:; {wenn Text blinkt}
CMP DH, 11;
JNE @nicht_11; {Farbe 3 wird zu Farbe 1}
MOV DH, 9;
JMP @blinkt_nicht;
@nicht_11:;
MOV DH, 8;
@blinkt_nicht:;
{ Hintergrund-Treatment }

SHL DH, 4;
ADD DL, DH;
MOV ES:[DI], DL;

POP DI;
POP ES;
END;

PROCEDURE TextLineGet(X,Y:BYTE; zielseg, zielofs: WORD; Laenge:BYTE);
ASSEMBLER;
ASM
PUSH ES;
PUSH DI;
PUSH DS;
PUSH SI;
MOV DS, zielseg;
MOV SI, zielofs;
MOV ES, TextDataSegm;
XOR CX, CX;
XOR BX, BX;
MOV CL, Y;
DEC CL;
MOV AX, CX;
SHL AX, 6;
MOV BL, X;
DEC BL;
ADD BX, AX;
MOV AX, CX;
SHL AX, 4;
ADD BX, AX;
SHL BX, 1;
MOV DI, BX;


MOV CL, Laenge;
MOV AX, 2;
@textget:;
MOV DX, ES:[DI];
MOV DS:[SI], DX;
ADD DI, AX;
ADD SI, AX;
LOOP @textget;

POP SI;
POP DS;
POP DI;
POP ES;

END;

PROCEDURE TextLinePut(X,Y:BYTE; quellseg, quellofs: WORD; Laenge:BYTE);
ASSEMBLER;
ASM
PUSH ES;
PUSH DI;
PUSH DS;
PUSH SI;
MOV DS, quellseg;
MOV SI, quellofs;
MOV ES, TextDataSegm;
XOR CX, CX;
XOR BX, BX;
MOV CL, Y;
DEC CL;
MOV AX, CX;
SHL AX, 6;
MOV BL, X;
DEC BL;
ADD BX, AX;
MOV AX, CX;
SHL AX, 4;
ADD BX, AX;
SHL BX, 1;
MOV DI, BX;


MOV CL, Laenge;
MOV AX, 2;
@textput:;
MOV DX, DS:[SI];
MOV ES:[DI], DX;
ADD DI, AX;
ADD SI, AX;
LOOP @textput;

POP SI;
POP DS;
POP DI;
POP ES;

END;



PROCEDURE TextPset(X, Y: BYTE; Zeichen: CHAR; Farbe, Hintergrund:BYTE);
BEGIN
DEC(X); DEC(Y);
memW[TextDataSegm:160*Y+X*2] := ORD(Zeichen)+256*Farbe + 4096*Hintergrund;
END;


PROCEDURE CLS;
VAR y:byte;
BEGIN
  for y := 1 to 25 do
  TextLineFill(1,y,chr(0),0,0,80);
  GOTOXY(1,1);textcolor(7);
END;


FUNCTION BoxInput(headline, help: STRING; Breite: BYTE): STRING;
  VAR Xstart, i, RealBreite: BYTE;
      inputstr: STRING[80];
      position: byte;
      KEY : WORD;
  LABEL again, enter;

BEGIN
  InputEscape := FALSE;

  RealBreite := Breite;
  IF ORD(headline[0]) > (RealBreite) THEN RealBreite := ORD(headline[0])+2;
  IF ORD(help[0]) > RealBreite THEN RealBreite := ORD(help[0]);
  INC (RealBreite, 10);
  Xstart := 39 - ROUND((RealBreite-5) / 2);

  FOR i := 6 TO 12 DO
  TextLineGet(1,i,seg(textbackup[i,1]), ofs(textbackup[i,1]),80);

  FOR i := 6 TO 11 DO
  TextLineFill(Xstart, i, CHR(0), 0, 7, RealBreite);

  TextPset(Xstart+3, 7, CHR(201), 0, 7);
  TextLineFill(Xstart+4, 7, CHR(205), 0,7, RealBreite - 8 );
  TextPset(Xstart+RealBreite-4, 7, CHR(187), 0, 7);

  TextPset(Xstart+3, 8, CHR(186), 0, 7);
  TextPset(Xstart+RealBreite-4,8, CHR(186),0,7);
  TextPset(Xstart+3, 9, CHR(186), 0, 7);
  TextPset(Xstart+RealBreite-4,9, CHR(186),0,7);

  {188}{200}
  TextPset(Xstart+3, 10, CHR(200), 0, 7);
  TextPset(Xstart+RealBreite-4,10, CHR(188),0,7);
  TextLineFill(Xstart+4, 10, CHR(205),0,7,RealBreite-8);

  GOTOXY(40-((ORD(headline[0])) div 2), 7);
  TextColor(0); TextBackGround(7);
  WRITE (' ',headline,' ');

  GOTOXY(Xstart + 5, 8);
  WRITE(help);

  TextLineFill(Xstart+5, 9, CHR(0), 0, 3, RealBreite - 10);
  GOTOXY(Xstart+5,9);

  FOR i := Xstart + 3 TO Xstart + 2 + RealBreite
  DO SHADOW (i, 12);

  FOR i := 7 TO 11 DO BEGIN
  SHADOW (Xstart+RealBreite, i);
  SHADOW (Xstart+RealBreite+1, i);
  SHADOW (Xstart+RealBreite+2, i);
  END;
{ Grafisch ist die Box nun dargestellt }



  Textcolor(0); TextBackground(3);
  position := 0;
  inputstr[0] := CHR(0);
again:;                            { Eingabe-Loop }
  GOTOXY(Xstart+5+position,9);
  KEY := INKEY;
  IF KEY > 0 THEN BEGIN
    CASE KEY OF
      8:     IF (ORD(inputstr[0]) > 0)
             AND (position > 0) THEN BEGIN
             IF position = ORD(inputstr[0]) THEN
               inputstr[0] := CHR(ORD(inputstr[0])-1)
             ELSE BEGIN
               FOR i := position TO ORD(inputstr[0])-1 DO
               inputstr[i] := inputstr[i+1];
               inputstr[0] := CHR(ORD(inputstr[0])-1);
             END;
               DEC(position);
             END;
      13:    GOTO Enter;
      27:    BEGIN InputEscape := TRUE; GOTO Enter; END;
      19200: IF position > 0 THEN DEC(position);
      19712: IF (position < (RealBreite-10))
             AND (position < ORD(inputstr[0]))
             THEN INC(position);
      18176: position := 0;
      20224: IF ORD(inputstr[0]) < (Realbreite - 10)
             THEN position := ORD(inputstr[0])
             ELSE position := Realbreite - 10;
      21248: IF ORD(inputstr[0]) > 0 THEN
             IF position < ORD(inputstr[0]) THEN BEGIN
             FOR i := position + 1 TO ORD(inputstr[0])-1 DO
             inputstr[i] := inputstr[i+1];
             inputstr[0] := CHR(ORD(inputstr[0])-1);
             END;
     32..254:IF (ORD(inputstr[0]) < (RealBreite - 10)) THEN
             BEGIN
               IF position = (ORD(inputstr[0]))
               THEN inputstr := inputstr + CHR(KEY)
               ELSE BEGIN
               inputstr[0] := CHR(ORD(inputstr[0])+1);
               FOR i := ORD(inputstr[0]) DOWNTO position + 2 DO
               inputstr[i] := inputstr[i-1];
               inputstr[position+1] := CHR(KEY);
               END;
               IF (position < (RealBreite - 10)) THEN INC(position);
             END;
    END;

    GOTOXY(Xstart+5,9);
    WRITE(inputstr);
    IF RealBreite-10-ORD(inputstr[0]) > 0 THEN
    TextLineFill(Xstart+5+ORD(inputstr[0]), 9, CHR(0),0,3,RealBreite-10-ORD(inputstr[0]));
  END;
GOTO again;

enter:;
  FOR i := 6 TO 12 DO         { HinterGrund restaurieren }
  TextLinePut(1,i,seg(textbackup[i,1]), ofs(textbackup[i,1]),80);
BoxInput := inputstr;
textcolor(7);
textbackground(0);
END;


PROCEDURE ErrMsg(headline, msg:STRING);
  VAR Xstart, i, RealBreite: BYTE;
BEGIN
  RealBreite := ORD(msg[0]);
  IF ORD(headline[0]) > (RealBreite) THEN RealBreite := ORD(headline[0])+2;
  INC (RealBreite,10);
  Xstart := 39 - ROUND((RealBreite-5) / 2);

  FOR i := 6 TO 11 DO
  TextLineGet(1,i,seg(textbackup[i,1]), ofs(textbackup[i,1]),80);

  FOR i := 6 TO 10 DO
  TextLineFill(Xstart, i, CHR(0), 15, 4, RealBreite);

  TextPset(Xstart+3, 7, CHR(201), 15, 4);
  TextLineFill(Xstart+4, 7, CHR(205), 15,4, RealBreite - 8 );
  TextPset(Xstart+RealBreite-4, 7, CHR(187), 15, 4);

  TextPset(Xstart+3, 8, CHR(186), 15, 4);
  TextPset(Xstart+RealBreite-4,8, CHR(186),15,4);

  TextPset(Xstart+3, 9, CHR(200), 15, 4);
  TextPset(Xstart+RealBreite-4,9, CHR(188),15,4);
  TextLineFill(Xstart+4, 9, CHR(205),15,4,RealBreite-8);

  GOTOXY(40-((ORD(headline[0])) div 2), 7);
  TextColor(15); TextBackGround(4);
  WRITE (' ',headline,' ');

  GOTOXY(41-((ORD(msg[0])) div 2), 8);
  WRITE(msg);

  FOR i := Xstart + 3 TO Xstart + 2 + RealBreite
  DO SHADOW (i, 11);

  FOR i := 7 TO 10 DO BEGIN
  SHADOW (Xstart+RealBreite, i);
  SHADOW (Xstart+RealBreite+1, i);
  SHADOW (Xstart+RealBreite+2, i);
  END;
{ Grafisch ist die Box nun dargestellt }

  CURSORattr(1,14,15);

wait;
  CURSORattr(0,14,15);
  FOR i := 6 TO 11 DO         { HinterGrund restaurieren }
  TextLinePut(1,i,seg(textbackup[i,1]), ofs(textbackup[i,1]),80);
textcolor(7);
textbackground(0);
END;


PROCEDURE Message(headline, msg:STRING);
  VAR Xstart, i, RealBreite: BYTE;
BEGIN
  RealBreite := ORD(msg[0]);
  IF ORD(headline[0]) > (RealBreite) THEN RealBreite := ORD(headline[0])+2;
  INC (RealBreite,10);
  Xstart := 39 - ROUND((RealBreite-5) / 2);

  FOR i := 6 TO 11 DO
  TextLineGet(1,i,seg(textbackup[i+7,1]), ofs(textbackup[i+7,1]),80);

  FOR i := 6 TO 10 DO
  TextLineFill(Xstart, i, CHR(0), 0, 7, RealBreite);

  TextPset(Xstart+3, 7, CHR(201), 0, 7);
  TextLineFill(Xstart+4, 7, CHR(205), 0,7, RealBreite - 8 );
  TextPset(Xstart+RealBreite-4, 7, CHR(187), 0, 7);

  TextPset(Xstart+3, 8, CHR(186), 0, 7);
  TextPset(Xstart+RealBreite-4,8, CHR(186),0,7);

  TextPset(Xstart+3, 9, CHR(200), 0, 7);
  TextPset(Xstart+RealBreite-4,9, CHR(188),0,7);
  TextLineFill(Xstart+4, 9, CHR(205),0,7,RealBreite-8);

  GOTOXY(40-((ORD(headline[0])) div 2), 7);
  TextColor(0); TextBackGround(7);
  WRITE (' ',headline,' ');

  GOTOXY(41-((ORD(msg[0])) div 2), 8);
  WRITE(msg);

  FOR i := Xstart + 3 TO Xstart + 2 + RealBreite
  DO SHADOW (i, 11);

  FOR i := 7 TO 10 DO BEGIN
  SHADOW (Xstart+RealBreite, i);
  SHADOW (Xstart+RealBreite+1, i);
  SHADOW (Xstart+RealBreite+2, i);
  END;
{ Grafisch ist die Box nun dargestellt }

{  CURSORattr(1,14,15);}

{wait;}
{  CURSORattr(0,14,15);}
textcolor(7);
textbackground(0);
END;

procedure clearmsg;
var i:byte;
begin
  FOR i := 6 TO 11 DO         { HinterGrund restaurieren }
  TextLinePut(1,i,seg(textbackup[i+7,1]), ofs(textbackup[i+7,1]),80);
end;

FUNCTION TextInput(headline, help:STRING; Breite:BYTE): STRING;
BEGIN
TextInput := BoxInput(headline, help, Breite);
END;

FUNCTION InputWord(headline, help:STRING; Breite: BYTE): WORD;
var code:integer;
    buf:word;
BEGIN
VAL(BoxInput(headline,help,Breite), buf, code);
InputWord := buf;
END;

FUNCTION InputLongInt(headline, help:STRING; Breite: BYTE): LONGINT;
var code:integer;
    buf: longint;
BEGIN
VAL(BoxInput(headline,help,Breite), buf, code);
InputLongInt := buf;
END;

FUNCTION InputReal(headline, help:STRING; Breite: BYTE): Real;
var code:integer;
buf: real;
BEGIN
VAL(BoxInput(headline,help,Breite), buf, code);
InputReal := buf;
END;


FUNCTION zustimmung(headline, help: STRING; default: boolean): boolean;

  VAR Xstart, i, RealBreite: BYTE;
      KEY : WORD;
      zustimm: boolean;
  LABEL again, enter;

procedure stell_dar;
begin
    if zustimm then begin
      gotoxy(36,9);
      textbackground(3);
      write(' Ja ');
      textbackground(7);
      write('  Nein ');
      gotoxy (39,9)
    end
    else begin
      gotoxy(36,9);
      textbackground(7);
      write(' Ja  ');
      textbackground(3);
      write(' Nein ');
      gotoxy(46,9);
    end;
end;

BEGIN
  InputEscape := FALSE;
  zustimm := default;

  RealBreite := 12;
  IF ORD(headline[0]) > (RealBreite) THEN RealBreite := ORD(headline[0])+2;
  IF ORD(help[0]) > RealBreite THEN RealBreite := ORD(help[0]);
  INC (RealBreite, 10);
  Xstart := 39 - ROUND((RealBreite-5) / 2);

  FOR i := 6 TO 12 DO
  TextLineGet(1,i,seg(textbackup[i,1]), ofs(textbackup[i,1]),80);

  FOR i := 6 TO 11 DO
  TextLineFill(Xstart, i, CHR(0), 0, 7, RealBreite);

  TextPset(Xstart+3, 7, CHR(201), 0, 7);
  TextLineFill(Xstart+4, 7, CHR(205), 0,7, RealBreite - 8 );
  TextPset(Xstart+RealBreite-4, 7, CHR(187), 0, 7);

  TextPset(Xstart+3, 8, CHR(186), 0, 7);
  TextPset(Xstart+RealBreite-4,8, CHR(186),0,7);
  TextPset(Xstart+3, 9, CHR(186), 0, 7);
  TextPset(Xstart+RealBreite-4,9, CHR(186),0,7);

  {188}{200}
  TextPset(Xstart+3, 10, CHR(200), 0, 7);
  TextPset(Xstart+RealBreite-4,10, CHR(188),0,7);
  TextLineFill(Xstart+4, 10, CHR(205),0,7,RealBreite-8);

  GOTOXY(40-((ORD(headline[0])) DIV 2), 7);
  TextColor(0); TextBackGround(7);
  WRITE (' ',headline,' ');

  GOTOXY(40-((ORD(help[0])) DIV 2), 8);
  WRITE(help);


  FOR i := Xstart + 3 TO Xstart + 2 + RealBreite
  DO SHADOW (i, 12);

  FOR i := 7 TO 11 DO BEGIN
  SHADOW (Xstart+RealBreite, i);
  SHADOW (Xstart+RealBreite+1, i);
  SHADOW (Xstart+RealBreite+2, i);
  END;
{ Grafisch ist die Box nun dargestellt }


  textcolor(0);
  stell_dar;
again:;                            { Eingabe-Loop }

  KEY := INKEY;
  IF KEY > 0 THEN BEGIN
    CASE KEY OF
      13:    GOTO Enter;
      27:    BEGIN InputEscape := TRUE; GOTO Enter; END;
      19200: zustimm := not zustimm; {links}
      19712: zustimm := not zustimm;     {rechts}
      18176: zustimm := true;
      20224: zustimm := false;
      ord('j'): begin
             zustimm := true;
             goto enter
             end;
      ord('J'): begin
             zustimm := true;
             goto enter
             end;
      ord('n'): begin
             zustimm := false;
             goto enter
             end;
      ord('N'): begin
             zustimm := false;
             goto enter
             end;
    END;

  { Hier die Darstellung }
  stell_dar;

  END;
GOTO again;

enter:;

  zustimmung := zustimm;
  FOR i := 6 TO 12 DO         { HinterGrund restaurieren }
  TextLinePut(1,i,seg(textbackup[i,1]), ofs(textbackup[i,1]),80);
{BoxInput := inputstr;}
textcolor(7);
textbackground(0);
END;



FUNCTION InitialVideo: STRING;
BEGIN
  IF (MEM[$40:$411] AND 48) = 32
    THEN InitialVideo := 'Co80'
    ELSE InitialVideo := 'Mono';
END;

FUNCTION INKEY: WORD;
  VAR I, W: BYTE;
BEGIN;
  I := 0; W := 0;
  ASM
    MOV AH, 0BH;
    INT 21H;
    CMP AL, 0FFH;
    JNE @ende
    MOV AH, 07H;
    INT 21H;
    CMP AL, 0;
    JNE @nur_ein_zeichen;
    MOV W, 0FFH;
    INT 21H;
    @nur_ein_zeichen:;
    MOV I, AL;
    @ende:;
  END;
  IF W = 0 THEN INKEY := I ELSE INKEY := 256*I;
END;

PROCEDURE WAIT;
BEGIN
WHILE INKEY = 0 DO;
END;

BEGIN
IF InitialVideo = 'Mono'
  THEN TextDataSegm := $B000
  ELSE TextDataSegm := $B800;
InputEscape := FALSE;
END.