unit interpl;

interface
function interpol:longint;

var track:byte;

implementation
uses dmfcheck,
     fdwinput,
     fdwparam,
     fio,
     calc1;



function interpol:longint;
var pos1, pos2, mpos1, mpos2: longint;
    m1, m2: real;
    sampnum:byte;
    looplen: longint;

procedure interpolier_mal;
begin
    if (pos1 = pos2) or (not interpol_on[track]) then
    begin
      if sample[sampnum]._16bit then
        interpol := inputdmf16(2*pos1+sample[sampnum].offset){*2048}
      else
        interpol := inputdmf8(pos1+sample[sampnum].offset)*256{*2048}
    end
    else
    begin

      m1 := 1 - (trackinfo[track].position - mpos1);
      m2 := 1 + (trackinfo[track].position - mpos2);

      if sample[sampnum]._16bit then
        interpol := TRUNC
         ( (inputdmf16(2*pos1+sample[sampnum].offset) * m1
           + inputdmf16(2*pos2+sample[sampnum].offset) * m2) ) {*2048}
      else
        interpol := TRUNC
         ( ( inputdmf8(pos1+sample[sampnum].offset) * m1
           + inputdmf8(pos2+sample[sampnum].offset) * m2 ) * 256) {*2048}

    end
end;

label vol_off;
begin
  if not trackinfo[track].volume_on then begin interpol := 0; goto vol_off end;

  sampnum := trackinfo[track].smp;
  pos1 := trunc(trackinfo[track].position);
  pos2 := fit(trackinfo[track].position);
  mpos1 := pos1;
  mpos2 := pos2;

if trackinfo[track].loop_on then
begin

  {if (pos1 < 0) then interpol := 0
  else}
 {if trackinfo[track].direction = 1 then}
{ begin}
  if pos2 > (sample[sampnum].loopend-1)
  then begin
         looplen := sample[sampnum].loopend-sample[sampnum].loopstart{+1};
         pos1 := (pos1 - sample[sampnum].loopend{length}+1) mod looplen + sample[sampnum].loopstart-1;
         pos2 := (pos2 - sample[sampnum].loopend{length}+1) mod looplen + sample[sampnum].loopstart-1;

       end;

  if pos1 < 0
  then begin
         looplen := sample[sampnum].loopend-sample[sampnum].loopstart{+1};
         pos1 := abs(pos1);
         pos1 := pos1 mod looplen;
         pos1 := (sample[sampnum].loopend-1-pos1) + sample[sampnum].loopstart-1;
         if pos2 < 0 then
           begin
             pos2 := abs(pos2);
             pos2 := pos2 mod looplen;
             pos2 := (sample[sampnum].length-1-pos1) + sample[sampnum].loopstart-1;
           end
           else
             pos2 := (pos2 - sample[sampnum].length+1) mod looplen + sample[sampnum].loopstart-1;

       end;


{ end}
{ else
 begin}


{ end;}
 interpolier_mal;

end
else
begin

  if pos1 < 0 then begin interpol := 0; trackinfo[track].smp := 0 end
  else
  if (pos2 > (sample[sampnum].length-1)) then
  begin
    interpol := 0;
    trackinfo[track].smp := 0
  end
  else

    interpolier_mal

end;


vol_off:

end; {interpol}




begin
track := 1;
end.