unit optimvol;

interface

procedure optimize_volume;
procedure optimize_volume_from_FDW;


implementation
uses fdwparam,
     calc1,
     pattload,
     stoppuhr,
     blknfo_1,
     fio,
     crt,
     dos,
     fdwinput,
     blknfo_2;

  var block: integer;
  last_block_to_process: integer;
  smallest_amp: real;


procedure create_fdw_file;
  label neuer_name,hey;
var fremdfile: file;
  D: DirStr;
  N: NameStr;
  E: ExtStr;
  strbuf: string[6];
  dwordbuf: longint;
  elapsed_time:real;
  ver: word;
begin
  neuer_name:;
  if existing(fdw_dateiname) then
  begin
    beep;
    if zustimmung('File '+fdw_dateiname+' is already existing', 'Overwrite?', false)
      then begin assign(fremdfile, fdw_dateiname);erase(fremdfile) end
    else
      begin
        hey:;
        fdw_dateiname := textinput('Please enter new name', 'Filename (.FDW):', 40);
        FSplit(fdw_dateiname, D, N, E);
        if N = '' then
        begin
           errmsg('Hey!', 'I said: PLEASE ENTER A NEW NAME!!!');
           goto hey;
        end;
        if E = '' then
        E := '.FDW';
        fdw_dateiname := D + N + E;
        goto neuer_name;
      end;
  end;

  round_up_Wav;
  close(outputfile);
  rename(outputfile, fdw_dateiname);
  reset(outputfile,1);
  strbuf := 'DWD';
  strbuf[0] := 'F';
  blockwrite(outputfile, strbuf[0], 4);
  blockread(outputfile, dwordbuf,4);
  seek(outputfile, dwordbuf);
  strbuf := 'DWDATA';
  strbuf[0] := 'F';
  blockwrite(outputfile, strbuf[0], 7);
  ver := $0204;
  blockwrite(outputfile, ver, 2);
  optimize_already := true;
  blockwrite(outputfile, optimize_already, 1);
  { FDW - Header ist fertig }

  blockwrite(outputfile, dateiname[1][0], ord(dateiname[1][0])+1);
  blockwrite(outputfile, dateiname[2][0], ord(dateiname[2][0])+1);
  { Dateinamen }

  blockwrite(outputfile, maxblocklen, sizeof(maxblocklen));
  blockwrite(outputfile, blockanz, sizeof(blockanz));
  blockwrite(outputfile, dmf_dauer, sizeof(dmf_dauer));
  { Werte, die durch get_dauer ermittelt wurden }

  blockwrite(outputfile, berechnete_sekunden, sizeof(berechnete_sekunden));
  elapsed_time := stoppuhr_secs;
  blockwrite(outputfile, elapsed_time, sizeof(elapsed_time));
{ blockwrite(outputfile, blockcount, sizeof(blockcount));}
  blockwrite(outputfile, outputsize, sizeof(outputsize));

  blockwrite(outputfile, smallest_amp, sizeof(smallest_amp));
  blockwrite(outputfile, last_block_to_process, sizeof(last_block_to_process));
  blockwrite(outputfile, block, sizeof(block));
  blockwrite(outputfile, mem[blklenseg:blklenofs],
   (last_block_to_process + 1) * 2);
  blockwrite(outputfile, mem[blkampseg:blkampofs],
   (last_block_to_process + 1) * 6);

  blockwrite(outputfile, stereo, 1);
  blockwrite(outputfile, mixfreq, 4);
  blockwrite(outputfile, _8bit, 1);

  close(outputfile);
  cls;
  textcolor(7);
  writeln ('FDW - file created: ', fdw_dateiname);
  writeln;
  writeln ('To continue calculation type: FDW2 /C:',fdw_dateiname);
  halt(0);
end;



procedure usermenu;

  var key: word;
begin
  stoppuhr_stop;
  cls;
  gotoxy(5,7); textcolor(2);write  ('   Please choose:');
  gotoxy(5,8);              write  ('   --------------');


  gotoxy(5,11); textcolor(3); write('1) Interrupt calculation and create .FDW - file (continue later)');

  gotoxy(5,13);               write('2) Continue calculation');


  repeat
    key := inkey;
    if key = 49 then create_fdw_file
  until key = 50;
  stoppuhr_start;


  cls;
end;



  procedure kompensiere_block(block: integer);

    procedure load_block(block:integer);
      var loadpos: longint;
          i:integer;
          m:byte;
    begin
      loadpos := 44;
      if _8bit then m := 1 else m := 2;
      if stereo then m := m * 2;
      for i := 0 to block-1 do
        inc(loadpos, block_laenge(i)*m);
      seek(outputfile, loadpos);
      { loadposition ist nun gesetzt }
      blockread(outputfile, memw[seg(writebuffer_poi^):ofs(writebuffer_poi^)],
        block_laenge(block)*m); { geladen, fertig }
    end;

    procedure save_block(block:integer);
      var savepos: longint;
          i:integer;
          m:byte;
    begin
      savepos := 44;
      if _8bit then m := 1 else m := 2;
      if stereo then m := m * 2;
      for i := 0 to block-1 do
        inc(savepos, block_laenge(i)*m);
      seek(outputfile, savepos);
      { saveposition ist nun gesetzt }
      blockwrite(outputfile, memw[seg(writebuffer_poi^):ofs(writebuffer_poi^)],
        block_laenge(block)*m); { gespeichert, fertig }
    end;


    var i: longint;
    intbuf: integer;
    shortintbuf: shortint;
    bytebuf: byte;
    buf: longint;
    kompensier_amp: real;
  begin {kompensiere_block}
    load_block(block);
{    writeln (block_amplify(block):0:10);}
    kompensier_amp := smallest_amp / block_amplify(block);
    cls;
    writeln ('kompensiere Lautstrke von Block #', block, ' (letzter Block: ', last_block_to_process,')');
    for i := 0 to block_laenge(block)-1 do

      if stereo and (not _8bit) then
      begin
        intbuf := memW[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*4];
        intbuf := trunc(intbuf * kompensier_amp);
        memW[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*4] := intbuf;
        intbuf := memW[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*4+2];
        intbuf := trunc(intbuf * kompensier_amp);
        memW[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*4+2] := intbuf;
      end
      else
      if stereo and _8bit then
      begin
        bytebuf := mem[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*2];
        shortintbuf := bytebuf - 128;
        shortintbuf := trunc(shortintbuf * kompensier_amp);
        bytebuf := shortintbuf + 128;
        mem[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*2] := bytebuf;
        bytebuf := mem[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*2+1];
        shortintbuf := bytebuf - 128;
        shortintbuf := trunc(shortintbuf * kompensier_amp);
        bytebuf := shortintbuf + 128;
        mem[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*2+1] := bytebuf;
      end
      else
      if (not stereo) and (not _8bit) then
      begin
        intbuf := memW[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*2];
        intbuf := trunc(intbuf * kompensier_amp);
        memW[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i*2] := intbuf;
      end
      else
      if (not stereo) and _8bit then
      begin
        bytebuf := mem[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i];
        shortintbuf := bytebuf - 128;
        shortintbuf := trunc(shortintbuf * kompensier_amp);
        bytebuf := shortintbuf + 128;
        mem[seg(writebuffer_poi^):ofs(writebuffer_poi^)+i] := bytebuf;
      end;

    save_block(block);
  end;



procedure optimize_volume;

  procedure search_last_block_to_process;
    var block:integer;
  begin
    last_block_to_process := -1;
    smallest_amp := block_amplify(0);
    for block := 0 to blockcount-1 do
{    begin writeln (block_laenge(block),'  ', block_amplify(block));wait; end;}
      if block_amplify(block) < smallest_amp then
      begin
        smallest_amp := block_amplify(block);
        last_block_to_process := block - 1
      end
  end;

begin


  search_last_block_to_process;

  textbackground(0);
  textcolor(7);

  for block := 0 to last_block_to_process do
  begin
    if inkey = 27 then usermenu;
    kompensiere_block(block);
  end;

end;


procedure optimize_volume_from_FDW;
  var startblock: integer;
      elapsed_time: real;
begin
(*********** laden **************)

  blockread(outputfile, maxblocklen, sizeof(maxblocklen));
  blockread(outputfile, blockanz, sizeof(blockanz));
  blockread(outputfile, dmf_dauer, sizeof(dmf_dauer));
  { Werte, die durch get_dauer ermittelt wurden }

  blockread(outputfile, berechnete_sekunden, sizeof(berechnete_sekunden));
  blockread(outputfile, elapsed_time, sizeof(elapsed_time));
  stoppuhr_set(elapsed_time);

  blockread(outputfile, outputsize, sizeof(outputsize));

  blockread(outputfile, smallest_amp, sizeof(smallest_amp));
  blockread(outputfile, last_block_to_process, sizeof(last_block_to_process));
  blockread(outputfile, startblock, sizeof(startblock));

  get_blocknfo1_mem;
  get_blocknfo2_mem;
  init_writebuffer;

  blockread(outputfile, mem[blklenseg:blklenofs],
   (last_block_to_process + 1) * 2);
  blockread(outputfile, mem[blkampseg:blkampofs],
   (last_block_to_process + 1) * 6);

  blockread(outputfile, stereo, 1);
  blockread(outputfile, mixfreq, 4);
  blockread(outputfile, _8bit, 1);


(*********** laden ENDE **************)

  for block := startblock to last_block_to_process do
  begin
    if inkey = 27 then usermenu;
    kompensiere_block(block);
  end;

end;


end.