
unit pattload;

interface

function pattern_instrument(trk:byte; row:word): byte;
function pattern_note(trk:byte; row:word): byte;
function pattern_volume(trk:byte; row:word): byte;
function pattern_inseff(trk:byte; row:word): byte;
function pattern_inseffwert(trk:byte; row:word): byte;
function pattern_noteff(trk:byte; row:word): byte;
function pattern_noteffwert(trk:byte; row:word): byte;
function pattern_voleff(trk:byte; row:word): byte;
function pattern_voleffwert(trk:byte; row:word): byte;


procedure load_pattern(nr:word);
procedure get_pattmem;
procedure get_dauer;
procedure read_global_track(tick:word);

type
  global_track_typ = record
    event: byte;
    data: byte;
  end;

var
    tracks: byte;
    tpb: byte;
    ticks: word;
    global_track: array[0..511] of global_track_typ;
    dmf_dauer: real;
    tickspeedsystem: boolean;
    bpmspeed, tickspeed: byte;
    tickdelay: byte;
    blockanz, blocklen, maxblocklen: longint;

implementation

uses dmfcheck,
     fdwinput,
     fdwparam,
     fio,
     fdw2_lch,
     fdw2_rch,
     calc1,
     blknfo_1,
     blknfo_2;
var
    poi: array[1..32] of pointer;

function pattern_instrument(trk:byte; row:word): byte;
begin
  pattern_instrument := mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row];
end;

function pattern_note(trk:byte; row:word): byte;
begin
  pattern_note := mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+1];
end;

function pattern_volume(trk:byte; row:word): byte;
begin
  pattern_volume := mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+2];
end;

function pattern_inseff(trk:byte; row:word): byte;
begin
  pattern_inseff := mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+3];
end;

function pattern_inseffwert(trk:byte; row:word): byte;
begin
  pattern_inseffwert := mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+4];
end;

function pattern_noteff(trk:byte; row:word): byte;
begin
  pattern_noteff := mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+5];
end;

function pattern_noteffwert(trk:byte; row:word): byte;
begin
  pattern_noteffwert := mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+6];
end;

function pattern_voleff(trk:byte; row:word): byte;
begin
  pattern_voleff := mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+7];
end;

function pattern_voleffwert(trk:byte; row:word): byte;
begin
  pattern_voleffwert := mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+8];
end;

procedure set_pattern_instrument(trk:byte; row:word; wert: byte);
begin
  mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row] := wert;
end;

procedure set_pattern_note(trk:byte; row:word; wert: byte);
begin
  mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+1] := wert;
end;

procedure set_pattern_volume(trk:byte; row:word; wert: byte);
begin
  mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+2] := wert;
end;

procedure set_pattern_inseff(trk:byte; row:word; wert: byte);
begin
  mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+3] := wert;
end;

procedure set_pattern_inseffwert(trk:byte; row:word; wert: byte);
begin
  mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+4] := wert;
end;

procedure set_pattern_noteff(trk:byte; row:word; wert: byte);
begin
  mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+5] := wert;
end;

procedure set_pattern_noteffwert(trk:byte; row:word; wert: byte);
begin
  mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+6] := wert;
end;

procedure set_pattern_voleff(trk:byte; row:word; wert: byte);
begin
  mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+7] := wert;
end;

procedure set_pattern_voleffwert(trk:byte; row:word; wert: byte);
begin
  mem[seg(poi[trk]^):ofs(poi[trk]^)+9*row+8] := wert;
end;



procedure load_pattern(nr:word);
  var p: longint;
      tick: word;
      track: byte;
      counter: array[0..32] of byte;
      buf,a,info: byte;
begin
  for track := 0 to 32 do
    counter[track] := 0;

  for tick := 0 to maxticks-1 do
  begin
    global_track[tick].event := 0;
    for track := 1 to maxtracks do
    begin
      set_pattern_instrument(track, tick, 0);
      set_pattern_note(track, tick, 0);
      set_pattern_volume(track, tick, 0);
      set_pattern_inseff(track, tick, 0);
      set_pattern_inseffwert(track, tick, 0);
      set_pattern_noteff(track, tick, 0);
      set_pattern_noteffwert(track, tick, 0);
      set_pattern_voleff(track, tick, 0);
      set_pattern_voleffwert(track, tick, 0);
    end;
  end;
(***** Datenfelder fr die Pattern-Daten sind nun gelscht ********)

  p := patternoffset[nr];
  tracks := inputdmf8(p);
  tpb := inputdmf8(p+1);
  tpb := tpb div 16;
  ticks := inputdmf16(p+2);


  p := patternoffset[nr] + 8; { bei +8 fngt's an }

  for tick := 0 to ticks-1 do
  begin
  {-------------------------}
    if counter[0] = 0 then
    begin
      buf := inputdmf8(p); inc(p);
      global_track[tick].event := buf and 63;
      if (buf and 128) > 0 then
      begin
        buf := inputdmf8(p); inc(p);
        counter[0] := buf + 1;
      end
      else
        counter[0] := 1;
      if global_track[tick].event > 0 then
      begin
        global_track[tick].data := inputdmf8(p);
        inc(p);
      end;
    end;
  {----------------------------}
    for track := 1 to tracks do
    begin
      if counter[track] = 0 then
      begin
        buf := inputdmf8(p);
        inc(p);
        info := buf;
        if (buf and 128) > 0 then
        begin
          buf := inputdmf8(p);
          inc(p);
          counter[track] := buf + 1;
        end
        else
          counter[track] := 1;
        if (info and 64) > 0 then
        begin
          set_pattern_instrument(track, tick, inputdmf8(p));
          inc(p);
        end;
        if (info and 32) > 0 then
        begin
          set_pattern_note(track, tick, inputdmf8(p));
          inc(p);
        end;
        if (info and 16) > 0 then
        begin
          set_pattern_volume(track, tick, inputdmf8(p));
          inc(p);
        end;
        if (info and 8) > 0 then
        begin
          set_pattern_inseff(track, tick, inputdmf8(p));
          inc(p);
          set_pattern_inseffwert(track, tick, inputdmf8(p));
          inc(p);
        end;
        if (info and 4) > 0 then
        begin
          set_pattern_noteff(track, tick, inputdmf8(p));
          inc(p);
          set_pattern_noteffwert(track, tick, inputdmf8(p));
          inc(p);
        end;
        if (info and 2) > 0 then
        begin
          set_pattern_voleff(track, tick, inputdmf8(p));
          inc(p);
          set_pattern_voleffwert(track, tick, inputdmf8(p));
          inc(p);
        end;
      end;
    end;
  {------------------------------}
    for a := 0 to 32 do
      if counter[a] > 0 then dec(counter[a]);
  {------------------------------}
  end;

end;


procedure read_global_track(tick:word);
var d,e: byte;
begin
  e := global_track[tick].event;
  tickdelay := 0;
  if e > 0 then
  begin
{    writeln ('Jawohl, sit!');}
{    halt(0);}
    d := global_track[tick].data;
    case e of
      1: begin
           tickspeed := d;
           tickspeedsystem := true;
           if tickspeed < 1 then tickspeed := 1;
         end;
      2: begin
           bpmspeed := d;
           tickspeedsystem := false;
           if bpmspeed < 1 then bpmspeed := 1;
         end;
      3: tpb := d;
      4: tickdelay := d;
      6: if tickspeedsystem then
         begin
           if (tickspeed + d) > 255 then tickspeed := 255 else inc(tickspeed, d)
         end
         else
         begin
           if (bpmspeed + d) > 255 then bpmspeed := 255 else inc(bpmspeed, d)
         end;
      7: if tickspeedsystem then
         begin
           if (tickspeed - d) < 1 then tickspeed := 1 else dec(tickspeed, d)
         end
         else
         begin
           if (bpmspeed - d) < 1 then bpmspeed := 1 else dec(bpmspeed, d)
         end;
    end;
  end;
end;

procedure abbruch(msg1, msg2: string);
begin
  close(inputdmf);
  beep;
  if kein_batchbetrieb then errmsg(msg1, msg2);
  cls;
  writeln ('FDW2 abgebrochen.');
  halt(1);
end;

procedure get_dauer;
  var i: word;
  tick: word;
  e,d:byte;
begin
  dmf_dauer := 0;
  blockanz := 0;
  maxblocklen := 0;
  for i := 1 to sequenzerentries do
  begin
    message('Schtze Dauer...', 'Sequenzer: '+intstr(i)+' von '+intstr(sequenzerentries));
    load_pattern(sequenzer[i]+1);
    for tick := 0 to ticks - 1 do
    begin
      read_global_track(tick);
      if tickspeedsystem then
        blocklen := round(mixfreq / (tickspeed)*4)
      else
        blocklen := round(mixfreq*60/bpmspeed/tpb);
{      if tickdelay > 0 then write('Hey!');}
      dmf_dauer := dmf_dauer + blocklen / mixfreq;
      dmf_dauer := dmf_dauer + blocklen / mixfreq * tickdelay / 16;
      inc(blockanz);
      inc(blockanz, fit(tickdelay / 16));
      if blocklen > maxblocklen then maxblocklen := blocklen;

    end;
    clearmsg;
  end;

  if maxblocklen > 16380 then abbruch('Error:', 'DMF too slow! ( -> Blocks too big)');
  get_lchan_mem;
  get_rchan_mem;
  init_writebuffer;

  if blockanz > 10920 then abbruch('Error:', 'DMF too long! (too many rows)');
  get_blocknfo1_mem;
  get_blocknfo2_mem;

end;


procedure get_pattmem;
  var i:byte;
begin
  for i := 1 to maxtracks do
    getmem(poi[i], 9*maxticks);
end;
begin

tickspeedsystem := true;
tickspeed := 32;
bpmspeed := 120;

end.