unit stoppuhr;

interface
procedure stoppuhr_start;
procedure stoppuhr_stop;
procedure stoppuhr_reset;
procedure stoppuhr_set(secs: real);
function stoppuhr_secs: longint;
function timestring(secs:longint): string;
var
stoppuhrticks: longint;

implementation
uses dos;

var oldvect: pointer;

procedure stoppuhr_inc;
interrupt;
begin
  asm cli end;
  inc(stoppuhrticks);
  asm sti end;
  port[$20] := $20;
end;

procedure stoppuhr_start;
begin
  asm cli end;
  getintvec($1c, oldvect);
  setintvec($1c, addr(stoppuhr_inc));
  asm sti end
end;

procedure stoppuhr_stop;
begin
  asm cli end;
  setintvec($1c, oldvect);
  asm sti end
end;

procedure stoppuhr_reset;
begin
  stoppuhrticks := 0
end;

procedure stoppuhr_set(secs: real);
begin
  stoppuhrticks := trunc(secs * 18.206481482);
end;


function stoppuhr_secs: longint;
begin
  stoppuhr_secs := trunc(stoppuhrticks / 18.206481482)
end;


function timestring(secs:longint):string;
  var bufstr: string;
  bufstr2: string[4];
  worksecs: longint;
  zahlstr: string[10];
begin
  bufstr := '';
  zahlstr := '0';

  if (secs div 3600) > 0 then
  begin
    str(secs div 3600, bufstr);
    zahlstr := bufstr;
    bufstr := bufstr + ' Stunde';
    if (secs div 3600) <> 1 then bufstr := bufstr + 'n'
  end;

  zahlstr := zahlstr + ':';
  if (secs div 3600) > 0 then worksecs := secs mod ((secs div 3600)*3600)
    else worksecs := secs;
  if (worksecs div 60) > 0 then
  begin
    str(worksecs div 60, bufstr2);
    if bufstr <> '' then
      if (worksecs mod ((worksecs div 60)*60)) > 0 then bufstr := bufstr + ', ' else bufstr := bufstr + ' und ';
    bufstr := bufstr + bufstr2 + ' Minute';
    if bufstr2[0] = chr(1) then zahlstr := zahlstr + '0';
    zahlstr := zahlstr + bufstr2;
    if (worksecs div 60) <> 1 then bufstr := bufstr + 'n'
  end else zahlstr := zahlstr + '00';

  if (worksecs div 60) > 0 then worksecs := worksecs mod ((worksecs div 60)*60);

  zahlstr := zahlstr + ':';
  if worksecs > 0 then
  begin
    str(worksecs, bufstr2);
    if bufstr <> '' then bufstr := bufstr + ' und ';
    bufstr := bufstr + bufstr2 + ' Sekunde';
    if bufstr2[0] = chr(1) then zahlstr := zahlstr + '0';
    zahlstr := zahlstr + bufstr2;
    if worksecs <> 1 then bufstr := bufstr + 'n'
  end else zahlstr := zahlstr + '00';

timestring := zahlstr + ' ('+bufstr+')';
end;

begin
  getintvec($1c, oldvect);
end.